#include "any2tfb.h"
#include "y.tab.h"
#include<string.h>
#include<stdio.h>


void index_inc(Symbol *);  /* $BMWAGHV9f$N$&$A(BNUMBER$B$r#1$DA}$d$9(B */
void inc(Symbol *);      /* $B>e$+$i8F$P$l$k4X?t(B */
int iwa_atoi(char *);   /* $BJ8;zNs(B->$B@0?t(B */
void iwa_itoa(int,char *);     /* $B@0?t(B->$BJ8;zNs(B */
void reverse(char *);   /* $BJ8;zNs$r5U$K$9$k(B*/

void change_transpose(Symbol *); /* $BE>CVI=8=(B->$B4X?tI=8=(B A.' ->transpose(A) */
void change_ctranspose(Symbol *); /*$BJ#AGE>CV(B->$B4X?tI=8=(B A'->ctranspose(A)*/

void change_mod(Symbol *);  /* mod$B$NJQ49(B */
void range_eq_to_assign(Symbol *); 
/*x=1..2$B$O$=$N$^$^$@$HJ}Dx<0(B(EQ)$B$H2r<a$5$l(Bx==1..2$B$K(B.ASSIGN$B$KJQ49(B(maple$B;~$@$1(B)*/

/*
  transform:
  $B%N!<%I$NJQ49(B 
*/
void transform(Symbol *sp)
{
  int i;
  if(sp->number==0){  /* $B;R6!$,#0(B */
	/* $B0J2<$N(Bifdef$B$O(Bmatlab2tfb$B$N$_$G$NJQ49(B */
#ifdef TRANSPOSE
	if(sp->type==TRANSPOSE)  /* $BE>CVI=8=(B A.'$B$NJQ49(B*/
	  change_transpose(sp);
	if(sp->type==CTRANSPOSE) /* $BJ#AGE>CVI=8=(B A'$B$NJQ49(B */
	  change_ctranspose(sp);
#endif 
	return;
  }
  else{
	if(src==MAPLE && sp->type==EQ)
	  range_eq_to_assign(sp);/* x=1..2$B$N$h$&$JJ8$OCOL#$KBeF~5-9f$G$J$/Ey9f(B */
	if(sp->type==FUNCTION)
	  list_to_range(sp);  /* $B4X?t$N;R$KJQ?t(B,$B<0(B,$B<0$N%j%9%H$,$"$C$?$i(BRANGE$B$X(B */
	if(sp->type==ELEMENT && src==ASIR) /*asir2tfb:$BMWAGHV9f$r#1$:$i$9(B($BA}$d$9(B)*/
	  index_inc(sp);        /* $B$d$C$F$$$k$3$H$O(BNUMBER$B$N;~$N<B:]$N(B+1$B7W;;(B */
	if((src==MATH && sp->type==FUNCTION && strcmp(sp->value,"Mod")==0) || (src==MAPLE && sp->type==OPE && strcmp(sp->value,"mod")==0) || (src==MATLAB && sp->type==FUNCTION && strcmp(sp->value,"rem")==0))
	  change_mod(sp);   /* mod$B$NJQ49(B */
	for(i=0;i<sp->number;i++){
	  transform(*((sp->childp)+i));   /* $B;R6!$KBP$7$F$bJQ49$r(B */
	}
  }
}



/*
  $B%N!<%I$NJQ49!'(B
  insert_down,insert_follow_down$B$N>\:Y$O(Btfb2any$B$N(Bcommon_file$B$NCf$N(B
  transform.c$B;2>H(B
*/
void insert_follow_down(Symbol *parent,Symbol *child,int i)
{
  int j;
  int k=parent->number;   /* $BJ]B8(B */
  for(j=0;j<parent->number-i;j++)   /* i$BHV0J9_$N;R$r=>$($k(B */
	child->childp[j]=parent->childp[i+j];
  for(j=i;j<parent->number;j++)
	parent->childp[j]=NULL;
  parent->number=parent->number-i;   /* $B;R$N?t$b2~$a(B.i$BHV$O;H$&$N$G(B-i$B$G(BOK */
  parent->childp[i]=child; /* $B>h$C<h$j(B */
  child->number=k-parent->number+1;   /* realloc$B$O9MN8$;$:(B. */
}


void insert_down(Symbol *parent,Symbol *child,int i)
{
  child->childp[0]=parent->childp[i]; /* i$BHV$NMWAG$r;R$K=>$($k(B */
  child->number=1;    /*$B;R$N?t$O(B1*/
  parent->childp[i]=child; /* $B>h$C<h$j(B */
}



void list_to_range(Symbol *sp)/*FUNCTION$B$N;R$G%j%9%H(B[$BJQ?t(B,expr,expr]$B$O(BRANGE$B$X(B*/
{
  int i;
  Symbol *tmp;
  if(src==ASIR){    /* asir2tfb$B$N;~(B */
	for(i=0;i<sp->number;i++)/*LIST$B$+%A%'%C%/(B.$BHO0O%j%9%H$O%a%s%P$,#3$D$N$O$:(B */
	  if((sp->childp[i])->type==LIST && (sp->childp[i])->number==3)
		if(((sp->childp[i])->childp[0])->type==HUTEIGEN){/*$B$5$i$K#1$D$aITDj85(B*/
		  tmp=makesymbol(RANGE,NULL);
		  insert_follow_down(sp->childp[i],tmp,1);
		  (sp->childp[i])->type=ASSIGN;
		}
  }
  if(src==MATH){    /* math2tfb$B$N;~(B */
	for(i=0;i<sp->number;i++)/*LIST$B$+%A%'%C%/(B.$BHO0O%j%9%H$O%a%s%P$,#3$D$N$O$:(B */
	  if((sp->childp[i])->type==LIST && (sp->childp[i])->number==3)
		if(((sp->childp[i])->childp[0])->type==VAR){/*$B$5$i$K#1$D$a$,JQ?t(B*/
		  tmp=makesymbol(RANGE,NULL);
		  insert_follow_down(sp->childp[i],tmp,1);
		  (sp->childp[i])->type=ASSIGN;
		}
  }
  /* maple2tfb$B$G$O2?$b$7$J$$(B */
}



/*
  mod$B$NJQ494X?t(Bchange_mod
     5%2   (asir)---|
   Mod[5,2](math)---|--->5%2(tfb:Asir$B$HF1$8(B)
   5 mod 2(maple)---|
*/
void change_mod(Symbol *sp)
{
  if(src==MATH || MATLAB){
	sp->type=OPE;
	strcpy(sp->value,"%"); /* $B85$h$jJ8;z?t>/$J$$$+$i3NJ]$7$J$*$5$J$$(B */
  }
  if(src==MAPLE){
	strcpy(sp->value,"%");
  }
  
}


/*
  $BMWAGHV9f$N$&$A$N(BNUMBER$B$r#1$:$i$9$?$a$N4X?t72(B
  $B$?$@$7(BNUMBER$B0J30$N=hM}$O(Bcheck_type$B$KG$$;$k(B
  (check_type$B$O(BNUMBER$B0J30$K(B"+1"$B$H$$$&J8;zNs$rIU$12C$($k$@$1(B)
*/
void index_inc(Symbol *sp)  /* $BMWAGHV9f$r#1A}$d$9(B */
{
  int i;
  for(i=0;i<sp->number;i++)
	inc(sp->childp[i]);
}


void inc(Symbol *sp)  /* $BA}$d$9(B */
{
  int i;
  char value[100];  /* $B7k2L$O(B100$B7e$^$G(BOK */
  char *tmp;
  if(sp->type==NUMBER){
	i=iwa_atoi(sp->value);
	i++;   /* $B#1$D$U$d$7$F(B */
	iwa_itoa(i,value);  /*$B7k2L$rJ8;zNs$X(B*/
	if(strlen(sp->value)<strlen(value)){
	  tmp=(char *)realloc(sp->value,strlen(value)+1); /* +1 for '\0' */
	  if(tmp==NULL)
		execerror("realloc,out of memory",(char *)0);
	  sp->value=tmp;  /* realloc$B@.8y(B */
	}
	strcpy(sp->value,value);
  }
}


int iwa_atoi(char *a)
{
  int i;
  int value;
  for(value=0,i=0;a[i]!='\0';i++){
	if(isdigit(a[i]))
	  value=10*value+(a[i]-'0');
	if(a[i]=='.')
	  execerror("index must be a integer",(char *)0);
  }
  return value;
}


void iwa_itoa(int n,char *value)
{
  int i=0;
  do{
	value[i++]=n%10+'0';   /* $B2<$N7e$+$i#1$D$:$DF~$l$F9T$/(B */
	n=n/10;
  }while(n);
  value[i]='\0';
  reverse(value);
}


void reverse(char *s)  /* $BJ8;zNs$r5U=g$K(B */
{
  int c;
  int i;
  int j;
  for(i=0,j=strlen(s)-1;i<j;i++,j--){ /* -1 for '\0' */
	c=s[i];
	s[i]=s[j];
	s[j]=c;
  }
}

/* 
   matlab2tfb$BMQ(B A' -> ctranspose(A)  ($BJ#AGE>CV(B)
                A.' ->transpose(A)  ($BE>CV(B)

  TRANSPOSE   -->   FUNCTION    $B=q$-49$($F$+$i;R$r$D$1$k$7$+L5M}(B
     A              transpose
                       |
                    HUTEIGEN
                       A
 */
void change_transpose(Symbol *sp) /*TRANSPOSE$B$,0z?t(B*/
{
  char *tmp;
  Symbol *sym=makesymbol(HUTEIGEN,sp->value); /* $B@h$K;R$r:n@.$7$H$$$F(Bpush */
  push(sym);             /* value$B$O=q$-49$($F$7$^$&$+$i@h$K:n$C$F$*$/(B */
  sp->type=FUNCTION; /* $B=q$-49$((B */
  tmp=(char *)realloc(sp->value,9);  /* transpose$B$N(B8$BJ8;z(B+'\0' */
  if(tmp==NULL)
	execerror("realloc ,out of memory",(char *)0);
  sp->value=tmp;  /* realloc$B@.8y(B */
  strcpy(sp->value,"transpose");
  appendchildren1(sp,1);  /* HUTEIGEN$B$r;R$K$D$1$F$*$7$^$$(B */
}


void change_ctranspose(Symbol *sp)
{
  char *tmp;
  Symbol *sym=makesymbol(HUTEIGEN,sp->value); /* $B@h$K;R$r:n@.$7$H$$$F(Bpush */
  push(sym);             /* value$B$O=q$-49$($F$7$^$&$+$i@h$K:n$C$F$*$/(B */
  sp->type=FUNCTION; /* $B=q$-49$((B */
  tmp=(char *)realloc(sp->value,10);  /* ctranspose$B$N(B9$BJ8;z(B+'\0' */
  if(tmp==NULL)
	execerror("realloc ,out of memory",(char *)0);
  sp->value=tmp;  /* realloc$B@.8y(B */
  strcpy(sp->value,"ctranspose");
  appendchildren1(sp,1);  /* HUTEIGEN$B$r;R$K$D$1$F$*$7$^$$(B */  
}


void range_eq_to_assign(Symbol *sp) /* x==1..2$B$H$J$C$F$7$^$&$N$r(Bx=1..2$B$K(B  */
{
  if(sp->type==EQ && sp->childp[0]->type==VAR && sp->childp[1]->type==RANGE)
	sp->type=ASSIGN;
}
