#include "any2tfb.h"
#include "y.tab.h"
#include<stdio.h>
#include<stdlib.h>
#define NSTACK 256
static Symbol *stack[NSTACK];
static Symbol **stackp=stack;

int i;    /* $B%P%0%A%'%C%/MQ(B */
void push(Symbol *sym)
{
  if(stackp>=&stack[NSTACK])
	execerror("stack too deep",(char *)0);
  *stackp++=sym;
  i++;              /* $B$3$N(B2$B9T$O%P%0%A%'%C%/MQ(B  */
  /* printf("push:%d \"%s\"\n",i,sym->value); */
}


Symbol *pop()
{
  if(stackp<=stack)
	execerror("stack under flow",(char *)0);
  i--;               /* $B$3$N(B2$B9T$O%P%0%A%'%C%/MQ(B */
  /* printf("pop:%d \"%s\"\n",i,(*(stackp-1))->value); */
  return *--stackp;
}


Symbol *pop_i(int i)    /* $B%9%?%C%/$G>e$+$i(Bi$BHVL\(B(1$B$+$i%+%&%s%H(B)$B$N<h$j=P$7(B*/
{
  int number; /* $B%W%C%7%e$5$l$F$$$k8D?t(B*/
  int k; /* $B%+%&%s%?(B */
  Symbol *tmp; /* return$B$7$?$$CM(B */
  number=((int)stackp-(int)stack)/sizeof(Symbol *);/*$B%9%?%C%/$K$"$k8D?t7W;;(B*/
  /* printf("number of stack:%d\n",number); */
  k=number-i;  /* $B>e$+$i(Bi$BHVL\$r;X$9(B */
  tmp=stack[k]; /* $B>C$9A0$KJ]B8(B */
  if(i>number||i<0)
	execerror("can't pop_i from stack!",(char *)0);
  for(  ; k<number-1 ; k++){
	stack[k]=stack[k+1];   /* $B2<$K5M$a$F9T$/(B */
  }
  stackp--;
  return tmp;
}


void init()  /* $B=i4|2=(B */
{
  stackp=stack;
  i=0;
}

/****

$B9=J8LZ:n@.4X?t72(B

****/


void appendchildren1(Symbol *sp,int number)/* sp$B$K;R6!$r(Bnumber$BJ,$@$1$D$1$k(B */
{                                            /* $B$5$i$K?F$K;R6!$N?t$rJ]B8(B */
  Symbol **tmp;                              /* $B$[$H$s$I$O$3$C$A$N#1$r;H$&(B */
  int i;
  if(number>=CHILD){     /* $B$D$1$k;R6!$,B?$9$.$?$i:F3NJ]$7$J$*$9(B  */
	tmp=(Symbol **)realloc(sp->childp,number*sizeof(Symbol *));
	if(tmp==NULL)             /* realloc$B<:GT(B */
	  execerror("realloc,out of memory",(char *)0);
	sp->childp=tmp;  /* $B@.8y(B  */	
  }
  for(i=number-1;i>=0;i--){       /* $B;R6!$rDI2C(B($B%]%C%W$7$J$,$i5U=g$K(B)  */
	(sp->childp)[i]=pop();     /* $B%W%C%7%e$7$F$*$$$?$b$N$H$D$J$2$k(B */    
  }  
  sp->number=number;           /* $B;R6!$N?t$rJ]B8(B */
}


void appendchildren2(Symbol *sp,int number)/* sp$B$K;R6!$r(Bnumber$BJ,$@$1$D$1$k(B */
{                                            /* $B$5$i$K?F$K;R6!$N?t$rJ]B8(B */
  Symbol **tmp;           
  int i;
  if(number>=CHILD){     /* $B$D$1$k;R6!$,B?$9$.$?$i:F3NJ]$7$J$*$9(B  */
	tmp=(Symbol **)realloc(sp->childp,number*sizeof(Symbol *));
	if(tmp==NULL)             /* realloc$B<:GT(B */
	  execerror("realloc,out of memory",(char *)0);
	sp->childp=tmp;  /* $B@.8y(B  */	
  }
  for(i=0;i<number;i++){       /* $B;R6!$rDI2C(B($B%]%C%W$7$J$,$iAGD>$K(B)  */
	*(sp->childp+i)=pop();     /* $B%W%C%7%e$7$F$*$$$?$b$N$H$D$J$2$k(B */    
  }  
  sp->number=number;           /* $B;R6!$N?t$rJ]B8(B */
}


Symbol *add()
{
  Symbol *sp=makesymbol(OPE,"+");
  appendchildren1(sp,2);   /*$B;R6!$rFs?M$V$i$5$2$k(B  */
  push(sp);
  return sp;
}


Symbol *sub()
{
  Symbol *sp=makesymbol(OPE,"-");
  appendchildren1(sp,2);
  push(sp);
  return sp;
}


Symbol *mul()
{
  Symbol *sp=makesymbol(OPE,"*");
  appendchildren1(sp,2);
  push(sp);
  return sp;
}


Symbol *divide()
{
  Symbol *sp=makesymbol(OPE,"/");
  appendchildren1(sp,2);
  push(sp);
  return sp;
}


Symbol *make_eq() /* $B4{$K:8JU1&JU$O%W%C%7%e$5$l$F$k$O$:$J$N$G0z?t$$$i$:(B*/
{
  Symbol *sp=makesymbol(EQ,NULL);
  appendchildren1(sp,2);
  push(sp);
  return sp;
  
}


Symbol *power()
{
  Symbol *sp=makesymbol(OPE,"^");
  appendchildren1(sp,2);
  push(sp);
  return sp;
}


Symbol *mod(char *a)
{
  Symbol *sp=makesymbol(OPE,a);
  appendchildren1(sp,2);
  push(sp);
  return sp;  
}


Symbol *unaryminus()
{
  Symbol *sp=makesymbol(UNARYMINUS,"-");
  appendchildren1(sp,1);
  push(sp);
  return sp;
}


Symbol *unaryplus()
{
  Symbol *sp=makesymbol(UNARYPLUS,"+");
  appendchildren1(sp,1);
  push(sp);
  return sp;
}


Symbol *assignment(Symbol *variable) 
{
  Symbol *sp=makesymbol(ASSIGN,NULL);
  push(variable);
  appendchildren2(sp,2);
  push(sp);
  return sp;
}


Symbol *kakko()
{
  Symbol *sp=makesymbol(PARENS,NULL);
  appendchildren1(sp,1);
  push(sp);
  return sp;
}


Symbol *makefunc(Symbol *sp,int number)
{
  appendchildren1(sp,number);
  push(sp);
  return sp;
}



Symbol *makelist(int number) /*[1,2]$B$H$$$&%j%9%H$+$i(B1,2$B$r?F(BLIST$B$K$V$i2<$2$k(B*/
{
  Symbol *sp=makesymbol(LIST,NULL);
  appendchildren1(sp,number);
  push(sp);
  return sp;
}


Symbol *make_element(Symbol *sp,int number) /* $B8e$KB3$/MWAG(B(a[2]$B$J$i(B2$B$N$3$H(B)*/
{	                                      /* $B$r(Ba$B$N;R$H$7$FIU$12C$($k(B */
  appendchildren1(sp,number);             /* $B:#$N>l9g?F$N(BELEMENT$B%H!<%/%s$O(Ba */
  push(sp);
  return sp;
}


Symbol *element_assign(Symbol *element,int number,Symbol *righthand)
{     /* $BMWAG$X$NBeF~J8$,2r<a$5$l$k$3$m$K$O:8JU$N(Bexpr($BMWAGHV9f(B)$B$H(B */
  Symbol *sp=makesymbol(ASSIGN,"=");  /* $B1&JU$N(Bexpr$B$,4{$K%W%C%7%e$5$l$F$$$k(B  */
  Symbol *tmp=pop();                  /* $B1&JU$N(Bexpr$B$r%]%C%W(B */ 
  appendchildren1(element,number);    /* $B:8JU$N:n@.(B  */
  push(element);     /* $B:8JU%W%C%7%e(B */
  push(tmp);         /* $B1&JU$N(Bexpr$B%W%C%7%e(B  */
  appendchildren1(sp,2);
  push(sp);         /* $B40@.$7$?$b$N$r%W%C%7%e(B */
  return sp;
}


/*   $BJ8$N2r<a=*$o$k:"$K$O4{$K0z?t$HMWAG$,$3$N=g$KJB$s$G$$$k(B    */
Symbol *makefunc_elem(Symbol *sp,int args,int elements)
{
  Symbol *tmp;
  Symbol *sym=makesymbol(FUNCTIONELEMENT,"");   /* $B>!<j$K(BELEMENT$BMWAG$r:n$j(B */
  Symbol *list=makesymbol(ELEMENT,"");
  appendchildren1(list,elements); /* $BMWAGHV9f$r$V$i2<$2(B */
  appendchildren1(sp,args);       /* $B4X?t$K0z?t$r$V$i2<$2(B  */
  push(sp);    /* $B4X?tIt%W%C%7%e(B */
  push(list);   /* $BMWAGIt%W%C%7%e(B */
  appendchildren1(sym,2);   /* +1 for ELEMENT$BMWAG(B */
  push(sym);
}


/*
    func_elem_assign:
    $B4X?t$+$iLa$C$F$-$?%j%9%H$NMWAG$X$NBeF~(B
    $B$3$N4X?t$r8F$S=P$9$3$m$K$O4{$K:8JU$N0z?t!"MWAGHV9f!"(B
    $B1&JU$N(Bexpr$B$,=g$K%W%C%7%e$5$l$F$$$k$O$:(B
 */
Symbol *func_elem_assign(Symbol *sp,int args,int elements,Symbol *righthand)
{
  Symbol *tmp=pop();  /* $B1&JU$N(Bexpr$B$rJ]B8(B */
  Symbol *asgn=makesymbol(ASSIGN,"=");
  Symbol *sym=makesymbol(FUNCTIONELEMENT,"");  /* $B>e$H;w$?$h$&$J$b$s(B */
  Symbol *list=makesymbol(ELEMENT,"");
  appendchildren1(list,elements);   /* $BMWAGHV9f$r;R$K$9$k(B */
  appendchildren1(sp,args);
  push(sp);
  push(list);
  appendchildren1(sym,2);    /* $B$3$3$^$G$G:8JU40@.(B */
  push(sym);     /* $B:8JU%W%C%7%e(B */
  push(tmp);     /* $BJ]B8$7$F$"$C$?1&JU$r%W%C%7%e(B */
  appendchildren1(asgn,2);   /* $BBeF~J840@.(B */
  push(asgn);         /* $BLZ$r%W%C%7%e(B */
}


