%{
  #include "../common_file/any2tfb.h"
  Symbol *makemodule(Symbol*,Symbol *); 
  Symbol *makeset(int);  
  Symbol *makevector_or_matrix(int);
  Symbol *makerange(void);
  void makecolumn(void);
%}

%union{   /* type of yylval */
  int narg;   /* number of args */
  Symbol *sym; /* pointer to symbol */
}

/*
  maple$B$G$O=89g$H%j%9%H$H9TNs$G;H$&5-9f$,$o$+$l$F$$$k(B
*/

%start list    /* $B%G%U%)%k%H$G$O(B1$BHV>e$N5,B'$+$i;O$^$k$N$G$3$l$O$J$/$F$b$h$$(B */
%token<sym> NUMBER VAR HUTEIGEN STRING    /* HUTEIGEN$B$O;H$o$J$$!#!#(B  */  
%token<sym> FUNCTION PREVIOUS CONST 
%token  MODULE /* $B%b%8%e!<%k4X?t8F$S=P$7(B:mymodule[f] */
%token VECTOR SET COLUMN EQ
/* VECTOR,SET,COLUMN,MOD$B$O(Bmaple$B%*%j%8%J%k(B:VECTOR,COLUMN$B$O>C5n(B */
%token PARENS LIST OPE   /* $B>.3g8L$HCf3g8L$H1i;;;R$HBeF~(B */
%token ELEMENT
%token FUNCTIONELEMENT   /* $B$3$l$b;H$o$J$$!#!#(B */
%type<sym> expr asgn
%type<narg> datalist end vectordata some  /* some$B$OMWAGCj=P$H%Q%C%1!<%84X?t8F$S=P$7$N6hJL$N$?$a(B */
 
%right ASSIGN   /* $B<B:]$K%H!<%/%s$H$7$F;H$&$N$O(Bmaple$B%*%j%8%J%k(B  */
%left '=' /* Maple$B$G$O$3$l$OJ}Dx<0(B */
%left MOD RANGE
%left '+' '-' 
%left '*' '/'
%left UNARYMINUS UNARYPLUS
%right '^'
%%

/*

  $B9=J8LZ:n@.4X?t$O4pK\E*$K(Basir2tfb$B$N$H$-$K:n$C$?(Btreemake.c$B$NCf?H$HF1$8(B
  ($B%3%T!<$7$?$b$N$r;H$&(B)

*/

list:   /* nothing */
| list end
| list expr end {print_expr(); printend($3);}
| list asgn end {print_expr(); printend($3);}
| list error end {yyerrok;}
;

end: ';' {$$=0;}
| ':' {$$=1;}
;

expr: NUMBER {push($1); $$=$1;}      /* $B?t;z(B */
| VAR  {push($1); $$=$1;}    /* $BJQ?t(Bor$BAH$_9~$_Dj?t(Bor$BAH$_9~$_4X?t(B */
| STRING {push($1); $$=$1;}          /* $BJ8;zNs(B */
| PREVIOUS {push($1); $$=$1;}        /* $BA02s$NEz$((B */
| CONST {push($1); $$=$1;}
| VAR '(' datalist ')' {$1->type=FUNCTION;$$=makefunc($1,$3);}/*$B4X?t8F$S=P$7(B*/
| '(' expr ')'         {$$=kakko();}
| expr '+' expr        {$$=add();}
| expr '-' expr        {$$=sub();}
| expr '*' expr        {$$=mul();}    
| expr '/' expr        {$$=divide();}
| expr '^' expr        {$$=power();}
| expr '=' expr        {$$=make_eq();}
| expr MOD expr        {$$=mod("mod");}
| expr RANGE expr      {$$=makerange();}
| '-' expr   %prec UNARYMINUS {$$=unaryminus();}
| '+' expr   %prec UNARYPLUS  {$$=unaryplus();}
| '[' datalist ']'  {$$=makelist($2);} /* list */
| '{' datalist '}' {$$=makeset($2);}  /* set:maple$B%*%j%8%J%k(B */
| '<' vectordata '>' {$$=makevector_or_matrix($2);}  /* vector:$BJQ49$OL5$7(B */
| VAR '[' datalist ']' some {  
   if($5==-1){
	 $1->type=ELEMENT;  /*$BMWAG<h$j=P$7(B*/ 
	 $$=make_element($1,$3);
   }
   else{	 /* $B%Q%C%1!<%84X?t8F$S=P$7(B */
	 Symbol *tmp; /* $B%9%?%C%/?<$/$KL2$k(Bf$B$N<h$j=P$7(B($B$H%9%?%C%/$+$i$N=|5n(B) */
	 if($3!=1)
	   execerror("invalid package call",(char *)0);
	 tmp=makemodule($1,pop_i($5+1)); /*$B%9%?%C%/$N1|?<$/$+$i(Bf$B$rH4$-$@$7(B*/
	 $$=makefunc(tmp,$5);
   }
  }  /* $BF0:nIt5-=R=*$o$j(B */
;    /* expr$BDj5A=*$o$j(B */

some:      {$$=-1;}
| '(' datalist ')' {$$=$2;}
;


vectordata: expr {$$=1;}
| vectordata ',' expr {$$=$1+1;}
| vectordata '|' expr {makecolumn(); $$=$1+1;}
;

asgn: VAR ASSIGN expr  {$$=assignment($1);}   /* $BJQ?t$X$NBeF~(B */
| VAR '[' datalist ']' ASSIGN expr {$1->type=ELEMENT; $$=element_assign($1,$3,$6);}/*$BMWAG$X$NBeF~(B*/
;

/* $B0z?t$d%j%9%H$J$I$G$N%G!<%?$N%j%9%H(B */
datalist:    {$$=0;}/* nothing */ 
| expr       {$$=1;}  
| datalist ','  expr  {$$=$1+1;} 
;
%%
/* end of grammer */


#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<setjmp.h>
#include<string.h>
char *progname;
int lineno=1;    /* for error message */
jmp_buf begin;
int skip(void);    /* $B%3%a%s%H$H$P$7!\<!$N%H!<%/%s(B */
int commentskip(void);
int searchconst(char *);    /* $BDj?t$N%F!<%V%k$r8+$FDj?t$+$I$&$+H=CG(B  */
int follow(int,int,int);     /* 2$BJ8;z%H!<%/%s$NFI$_9~$_(B */

short src=MAPLE;  /* $B$I$N%=%U%H$+$i$NJQ49$+(B */

main(int argc,char *argv[])
{
  progname=argv[0];
  setjmp(begin);
  yyparse();
}


int yylex(void)
{
  int c;
  int c1;
  char value[200];   /* $B;CDjE*$K?t;zNs$dJQ?t$NL>A0$J$I$rF~$l$kNN0h(B */
  char *p=value;
  
  c=skip();     /* $B%3%a%s%H2~9T6uGr%?%V$O$H$P$7(B */
  while(c=='#'){    /* $B$5$i$K%3%a%s%H$,$"$C$?$J$i$P(B */
	c=commentskip();
  }
  if(c==EOF)
	return 0;
  if(isdigit(c)){     /* NUMBER */
	do{
	  *p++=c;
	}while((c=getchar())!=EOF && isdigit(c));
	if(c!='.'){         /* $B>.?t$G$J$$(B */
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(NUMBER,value);
	  return NUMBER;
	}                         /* $B>.?tE@$N<!$rFI$`(B  */
	if((c1=getchar())=='.'){   /* $B>.?tE@$,#2$DO"B3$G$-$?(B->RANGE */
	  ungetc(c1,stdin);   /* .$B$rFs$DI8=`F~NO$XJV4T(B  */
	  ungetc(c1,stdin);
	  *p='\0';
	  yylval.sym=makesymbol(NUMBER,value);
	  return NUMBER;
	}
	ungetc(c1,stdin);    /* 1$BJ8;zJV4T(B  */
	do{                 /* $B>.?tE@0J2<$N%3%T!<(B */
	  *p++=c;
	}while((c=getchar())!=EOF && isdigit(c));
	*p='\0';
	ungetc(c,stdin);
	yylval.sym=makesymbol(NUMBER,value);
	return NUMBER;
  }
  if(isalpha(c)){  /* $B%"%k%U%!%Y%C%H$G;O$^$k(B->$BJQ?t(Bor$BAH$_9~$_Dj?t(Bor$B4X?t(B */
	do{
	  *p++=c;
	}while((c=getchar())!=EOF && (isalnum(c) || c=='_'));
	*p='\0';
	ungetc(c,stdin);
	if(searchconst(value)==1){
	  yylval.sym=makesymbol(CONST,value);
	  return CONST;
	}
	else if(strcmp(value,"mod")==0)
	  return MOD;
	yylval.sym=makesymbol(VAR,value);
	return VAR;
  }
  if(c=='"'){       /* $BJ8;zNs(B */
	for(;(c=getchar())!='"';p++){
	  if(c=='\n' || c==EOF){
		execerror("missing quote","");
	  }
	  if(p>=value+sizeof(value)-1){
		*p='\0';
		execerror("string too long",value);
	  }
	  *p=c;
	}
	*p='\0';
	yylval.sym=makesymbol(STRING,value);
	return STRING;
  }
  if(c=='%'){    /* %$B$OD>A0$NEz$((B,%%$B$O(B2$B2sA0(B */
	*p++='%';       /* $BF~$l$H$$$F(B */
	if((c=getchar())=='%'){  
	  do{
		*p++=c;
	  }while((c=getchar())=='%');
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(PREVIOUS,value);
	  return PREVIOUS;
	}
	else{    /* %$B$N$_(B */
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(PREVIOUS,value);
	  return PREVIOUS;
	}
  }  
  return c;    /* default */
}  


int yyerror(char *s) /* call from yyparse when syntax error exists */
{
  warning(s,(char *)0);
}

int warning(char *s,char *t)
{
  fprintf(stderr,"%s: %s",progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  fprintf(stderr," near line %d\n",lineno);
}


void execerror(char *s,char *t)
{
  warning(s,t);
  longjmp(begin,0);
}


int skip()   /* asir2tfb$B$NL>;D!#$3$3$r4X?t$KJ,$1$kI,MW$O$J$+$C$?$+$b(B  */    
{
  int c;   
  for((c=getchar()) ; ; ){
	switch(c){               
	case ' ': case '\t':  /* $B6uGr$OFI$_$H$P$7(B */
	  c=getchar(); 
	  break;
	case '\n':    /* $B2~9T$-$?(B */
	  lineno++;
	  c=getchar();
	  break;
	case '#':             /* #$B$,$-$?(B->$B9TKv$^$G%3%a%s%H(B */
	  c=commentskip();    /* $B%3%a%s%H$rFI$_$H$P$7(B */
	  return c;
	  break;
	case '.':
	  c=follow('.',RANGE,'.');
	  return c;
	  break;
	case ':':
	  c=follow('=',ASSIGN,':');
	  return c;
	  break;
	default:
	  return c;
	  break;
	}
  }  
}


int commentskip()
{
  int c;
  while((c=getchar())!=EOF && c!='\n')   /* $B2~9T$^$G$O$H$P$7(B */
	;
  while(c=='\n'){    /* $B2~9T$^$GMh$?$i(B */
	lineno++;     /* $B2~9T$,2?9T$"$k$+$o$+$i$J$$(B  */
	c=getchar();  /* $B9T?t$r$U$d$7$F$=$N<!$NJ8;z$rFI$`(B */
  }
  return c;
}

#define A 10   /* $B8D?t(B */
int searchconst(char *value)    /* $BFI$_9~$s$@$b$N$,Dj?t$+$I$&$+$rAmEv$?$j$G%A%'%C%/$9$k(B */
{
  int i;
  char *const_table[A]={
	"I",
	"infinity",
	"Pi",
	"gamma",
	"Catalan",
	NULL
  };
  for(i=0;const_table[i]!=NULL;i++){/* $B8!:w!'>/$J$$$7AmEv$?$j$G$b$$$$$G$7$g$&(B*/
	if(strcmp(value,const_table[i])==0)
	  return 1;
  }
  return 0;
}


int follow(int expect,int ifyes,int ifno)  /* look ahead for == etc.. */
{
  int c;
  c=getchar();
  if(c==expect)
	return ifyes;
  else{
	ungetc(c,stdin);
	return ifno;
  }
}



/*
  maple$B$@$1$N9=J8LZ:n@.4X?t(B
*/
Symbol *makevector_or_matrix(int number)  /* maple$B$@$1$+$J!)(B */
{
  Symbol *vector=makesymbol(VECTOR,NULL);
  appendchildren1(vector,number);  /* $B;R$r$V$i2<$2$k(B */
  push(vector);
  return vector;
}


Symbol *makerange()      /* maple$B$@$1!)(B */
{
  Symbol *range=makesymbol(RANGE,NULL);
  appendchildren1(range,2);
  push(range);
  return range;
}


void makecolumn()    /* maple$B$@$1!)(B | $B$N2<$K(Bexpr$B$r$V$i2<$2$k(B */
{
  Symbol *tmp=makesymbol(COLUMN,"|");
  appendchildren1(tmp,1);    /* $B0lHV>e$N(Bexpr$B$r;R6!$K(B  */
  push(tmp);
}


Symbol *makeset(int number)
{
  Symbol *sp=makesymbol(SET,NULL);
  appendchildren1(sp,number);
  push(sp);
  return sp;
}


/* module[f]->module.f */
Symbol *makemodule(Symbol *module,Symbol *f)  /* module$B$N7A$r:n@.(B */
{
  int i=strlen(module->value)+strlen(f->value)+2;/*+1for '\0',more +1 for '.'*/
  char str[i]; /* $BJ8;zNs:n@.MQ(B */
  Symbol *tmp;
  str[0]='\0'; /* $BG0$N$?$a:G=i$NMWAG$@$1=i4|2=(B*/
  strcat(str,module->value); /* $B6u$K(Bmodule$BJ8;zNsDI2C(B */
  strcat(str,".");   /* $BB3$$$F(B"."$BDI2C(B */
  strcat(str,f->value);  /* $B:G8e$K(Bf$BDI2C(B*/
  tmp=makesymbol(MODULE,str);
  return tmp;
}
