%{
  #include "../common_file/any2tfb.h"
  /* matlab$BMQ9=J8LZ:n@.4X?t(B */
  void makerow(int);    /*MATLAB$B@lMQ9=J8LZ:n@.4X?t(B:$B9TNs$N9T$r:n@.(B */
  Symbol *makerange(void); 
  Symbol *makerangestep(void); /* step$BIU$-HO0OI=8=(B */
  void swap(Symbol*,int,int);  /* $B;R$NF~$l49$((B*/
%}

%union{   /* type of yylval */
  int narg;   /* number of args */
  Symbol *sym; /* pointer to symbol */
}

/*
  matlab$B$G$O(B
  $BBgJ8;z$+$i$O$8$^$k%*%V%8%'%/%H$r@hF,$O>.J8;z$KD>$9(B
  $B$J$+$J$+$KFC<l$G$9$Y$F$N%*%V%8%'%/%H$O9TNs$H$7$F07$o$l$k(B
  $B9TNs$NI=8=(B [1,2;3,4] --->  1  2   ,$B$O%9%Z!<%9(B  ;$B$O2~9T$G$b$h$$(B
                             3  4
*/

%start list    /* $B%G%U%)%k%H$G$O(B1$BHV>e$N5,B'$+$i;O$^$k$N$G$3$l$O$J$/$F$b$h$$(B */
%token<sym> NUMBER VAR HUTEIGEN STRING /*HUTEIGEN:$B6&DL%b%8%e!<%k$N$?$a$N$_(B*/  
%token <sym>FUNCTION PREVIOUS CONST /* VAR:$B%W%m%0%i%_%s%0$G$NJQ?t(B */
%token PARENS LIST OPE ASSIGN      /* $B>.3g8L$HBg3g8L$H1i;;;R$HBeF~1i;;;R(B */
%token RANGE   /* $BHO0O(B */
%token ELEMENT            /* $BMWAGCj=P$N:]$NJQ?t(B */
%token FUNCTIONELEMENT    /* $B;H$o$J$$(B */
%token ROW    /* $B9TNs$N9T(B:matlab$B%*%j%8%J%k(B */
%token RANGEST  /* step$BIU$-(BRANGE(rangestep) */
%token<sym> TRANSPOSE /* HUTEIGEN(or VAR)+.'($BE>CV$rI=$9(B.):matlab$B%*%j%8%J%k(B */
%token<sym> CTRANSPOSE /* HUTEIGEN(or VAR)+'($BJ#AGE>CV$rI=$9(B):matlab */
%type<sym> expr asgn matrix range
%type<narg> datalist end matrixdata row

%right '='
%left EQ    /* ==$B$N$3$H(B */
%left '+' '-'
%left '*' '/'
%left UNARYMINUS UNARYPLUS   /* $BC19`%^%$%J%9(B,$B%W%i%9(B */
%right '^'
%%

list:   /* nothing */
| list end
| list expr end   {print_expr(); printend($3);}
| list asgn end   {print_expr(); printend($3);}
| list matrix end {print_expr(); printend($3);}
| list range end {print_expr(); printend($3);}
| list error end  {yyerrok;}
;

end: '\n' {$$=0;}
| ';'    {$$=1;}
;

/***************
NUMBER:$B?t;z(B
VAR:$BBeF~$,$5$l$?(BHUTEIGEN($BMWAGCj=P$NJ8K!$H4X?t8F$S=P$7$NJ8K!$N6hJL$N$?$a(B)
HUTEIGEN:$B$^$@BeF~$5$l$F$$$J$$JQ?t(B
STRING:$BJ8;zNs(B-> '...'
CONST:$BDj?t(B
PREVIOUS:$BA02s$NEz$((B --> $BB?J,(BMATLAB$B$K$O$J$$(B
$B$A$J$_$K(B{$$=$1;}$B$O%G%U%)%k%H%"%/%7%g%s$J$N$G>JN,2DG=(B
HUTEIGEN '(' datalist ')' ->$B4X?t8F$S=P$7(B
HUTEIGEN '(' datalist ')' index ->$B<B8=$-$D$=$&(B
***************/

expr: NUMBER {push($1); $$=$1;} 
| VAR        {push($1); $$=$1;}
| HUTEIGEN   {push($1); $$=$1;}
| STRING     {push($1); $$=$1;}
| CONST      {push($1); $$=$1;} 
| TRANSPOSE  {push($1); $$=$1;}  /* $BE>CVI=8=(B:A.'$B$J$I(B */
| CTRANSPOSE {push($1); $$=$1;}  /* $BJ#AGE>CVI=8=(B:A'$B$J$I(B */
| PREVIOUS   {push($1); $$=$1;} /* $B=P$FMh$k$3$H$O$J$$(B */
| HUTEIGEN '(' datalist ')' {$1->type=FUNCTION;$$=makefunc($1,$3);}
| '(' expr ')'   {$$=kakko();}
| expr '+' expr  {$$=add();}
| expr '-' expr  {$$=sub();}
| expr '*' expr  {$$=mul();}
| expr '/' expr  {$$=divide();}
| expr '^' expr  {$$=power();}
| expr EQ expr   {$$=make_eq();}
| '-' expr   %prec UNARYMINUS {$$=unaryminus();} 
| '+' expr   %prec UNARYPLUS  {$$=unaryplus();} 
| VAR '(' datalist ')' {$1->type=ELEMENT;$$=make_element($1,$3);}/*$BMWAG<h=P$7(B*/
;

range: expr ':' expr     {$$=makerange();}
| expr ':' expr ':' expr {$$=makerangestep();} 
;

asgn: VAR '=' expr {$$=assignment($1);}   /* $BJQ?t$X$N:FBeF~(B */
| HUTEIGEN '=' expr {$1->type=VAR;install($1->value);$$=assignment($1);}
/*$BBeF~(B*/
| VAR '=' matrix {$$=assignment($1);}  /* $B9TNs(Bor$B%j%9%H(Bor$B%Y%/%H%k$NBeF~(B */
| HUTEIGEN '=' matrix {$1->type=VAR;install($1->value);$$=assignment($1);}
| VAR '(' datalist ')' '=' expr{$1->type=ELEMENT;$$=element_assign($1,$3,$6);}
/*$BMWAGBeF~(B*/
|  HUTEIGEN '=' range {$1->type=VAR;install($1->value);$$=assignment($1);}
|  VAR '=' range {$$=assignment($1);}
;

matrix: '[' matrixdata ']' {$$=makelist($2);}  /*vector or matrix or list*/
;


/* $B0z?t$J$I$G$N%G!<%?$N%j%9%H(B */
datalist:  {$$=0;}  /* nothing */ 
| expr     {$$=1;}   
| datalist ',' expr {$$=$1+1;} 
;


/* matrix$B$N%G!<%?(B */
matrixdata: row {makerow($1);$$=1;}  /* $B9T(B */
| matrixdata ';' row {makerow($3);$$=$1+1;}
| matrixdata '\n' row {makerow($3);$$=$1+1;}
;


row:  {$$=0;} /*nothing*/
| expr {$$=1;}
| row ',' expr {$$=$1+1;}
;

%%
/* end of grammer */


#include<stdio.h>
#include<ctype.h>
#include<setjmp.h>
#include<string.h>
char *progname;
int lineno=1;    /* for error message */
jmp_buf begin;
int skip(void);   /* $B6uGr2~9T$OHt$P$7$F<!$N(B1$BJ8;z$rFI$_9~$`(B */
int commentskip(void);  /* $B%3%a%s%H$rFI$_$H$P$9(B */
int follow(int,int,int);    /* 2$BJ8;z$+$i$J$k%H!<%/%s$N2DG=@-$rD4$Y$k(B */
int searchconst(char *);   /* $BDj?t$+$I$&$+$r%F!<%V%k$+$i%A%'%C%/(B */

short src=MATLAB;  /* $B$I$N%=%U%H$+$i$NJQ49$+(B */

main(int argc,char *argv[])
{
  progname=argv[0];
  setjmp(begin);
  yyparse();
}


/***************************
NUMBER:$B?t;z(B -> value$B$K$O?t;zNs(B
VAR:$BJQ?t(B    -> value$B$K$OJQ?tL>(B
HUTEIGEN:$BITDj85(B -> value$B$K$OITDj85L>(B
STRING:$BJ8;zNs(B   -> value$B$K$O%7%s%0%k%/%*!<%H$r=|$$$?J8;zNs(B
CONST:$BDj?t(B      -> value$B$K$ODj?tL>(B
***************************/

int yylex(void)
{
  int c;
  char value[200];   /* $B;CDjE*$K?t;zNs$dJQ?t$NL>A0$J$I$rF~$l$kNN0h(B */
  char *p=value;
 
  c=skip();     /* $B%3%a%s%H2~9T6uGr%?%V$O$H$P$7$?#1J8;zL\$r<h$C$FMh$k(B */
  /* printf("%c\n",c);     $B%G%P%C%0MQ(B */
  if(c==EOF)
	return 0;
  if(isdigit(c)){     /* NUMBER */
	do{
	  *p++=c;
	}while((c=getchar())!=EOF && isdigit(c));
	if(c!='.'){         /* $B>.?t$G$J$$(B */
	  *p='\0';
	  ungetc(c,stdin);
	  yylval.sym=makesymbol(NUMBER,value);
	  return NUMBER;
	}
	do{                 /* $B>.?tE@0J2<$N%3%T!<(B */
	  *p++=c;
	}while((c=getchar())!=EOF && isdigit(c));
	*p='\0';
	ungetc(c,stdin);
	yylval.sym=makesymbol(NUMBER,value);
	return NUMBER;
  }
  
  if(isalpha(c)){    /* $B1Q;z$+$i;O$^$k%*%V%8%'%/%H(B->HUTEIGEN,VAR,CONST? */
	do{
	  *p++=c;
	}while((c=getchar())!=EOF && (isalnum(c) || c=='_'));

	if(c=='\''){    /* $BE>CVI=8=$+$I$&$+(B($B1Q;zNs(B+') */
	  *p='\0';
	  yylval.sym=makesymbol(CTRANSPOSE,value);   /* $BJ#AGE>CVI=8=(B */
	  return CTRANSPOSE;   /* '$B$OFI$_Ht$P$7$?$$$N$G(Bungetc$B$O$7$J$$(B */
	}

	if(c=='.'){    /* $BE>CVI=8=!)Nc(B: A.' $B$+!)(B */
	  if(follow('\'',TRANSPOSE,'.')==TRANSPOSE){
		*p='\0';
		yylval.sym=makesymbol(TRANSPOSE,value);  /* $BE>CVI=8=(B */
		return TRANSPOSE;
	  }
	}

	*p='\0';
	ungetc(c,stdin);
	if(lookup(value)==1){   /* $BJQ?t%F!<%V%k$r8!:w$7$F8+$D$+$C$?(B */
	  yylval.sym=makesymbol(VAR,value);  /* $BJQ?t(B */
	  return VAR;
	}
	else if(searchconst(value)==1){   /* $BDj?t$+$I$&$+$NH=CG(B */
	  yylval.sym=makesymbol(CONST,value);
	  return CONST;
	}
	else{
	  yylval.sym=makesymbol(HUTEIGEN,value);
	  return HUTEIGEN;  /* $BITDj85(B */
	}
  }
  
  if(c=='\''){
	for(;(c=getchar())!='\'';p++){
	  if(c=='\n' || c==EOF){
		execerror("missing quote","");
	  }
	  if(p>=value+sizeof(value)-1){
		*p='\0';
		execerror("string too long",value);
	  }
	  *p=c;
	}
	*p='\0';
	yylval.sym=makesymbol(STRING,value);
	return STRING;
  }
  if(c=='\n')   /*matlab$B$G$O2~9T$b%H!<%/%s$N#1$D(B*/
	lineno++;
  return c;    /* default */
}  


int yyerror(char *s) /* call from yyparse when syntax error exists */
{
  warning(s,(char *)0);
}


int warning(char *s,char *t)
{
  fprintf(stderr,"%s: %s",progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  fprintf(stderr," near line %d\n",lineno);
}


void execerror(char *s,char *t)
{
  warning(s,t);
  init();  /* $B%9%?%C%/$r#0$K(B */
  longjmp(begin,0);
}


int skip()
{
  int c;   
  for((c=getchar()) ; ; ){
	switch(c){               
	case ' ': case '\t':  /* $B6uGr$OFI$_$H$P$7(B */
	  c=getchar(); 
	  break;
	case '%':             /* #$B0J9_$O%3%a%s%H(B */
	  c=commentskip();    /* $B%3%a%s%H$rFI$_$H$P$7(B */
	  return c;
	  break;
	case '=':   
	  return follow('=',EQ,'=');
	default:
	  return c;
	  break;
	}
  }  
}


int commentskip()
{
  int c;
  while((c=getchar())!=EOF && c!='\n'){   /* $B2~9T$^$G$O$H$P$7(B */
	if(c=='\n'){    /* $B2~9T$^$GMh$?$i(B */
	  lineno++;     /* $B2~9T$,2?9T$"$k$+$o$+$i$J$$(B  */
	  c=getchar();  /* $B9T?t$r$U$d$7$F$=$N<!$NJ8;z$rFI$`(B */
	}	
  }
  if(c=='%')
	commentskip();
  return c;
}


#define A 10   /* $B8D?t(B */
int searchconst(char *value) /*$BFI$_9~$s$@$b$N$,Dj?t$+$rAmEv$?$j$G%A%'%C%/(B*/
{
  int i;
  char *const_table[A]={
	"i",    /* $B5u?t$O(Bi$B$b$7$/$O(Bj$B$GI=$9(B  */
	"j",
	"inf",
	"Inf",
	"pi",
	NULL
  };
  for(i=0;const_table[i]!=NULL;i++){/* $B8!:w!'>/$J$$$7AmEv$?$j$G$b$$$$$G$7$g$&(B*/
	if(strcmp(value,const_table[i])==0)
	  return 1;
  }
  return 0;
}


int follow(int expect,int ifyes,int ifno)  /* look ahead for == etc.. */
{
  int c;
  c=getchar();
  if(c==expect)
	return ifyes;
  else{
	ungetc(c,stdin);
	return ifno;
  }
}



/*
  MATLAB$B@lMQ$N9=J8LZ:n@.4X?t72(B
  makerow:$B9T$K4X$9$k9=J8LZ$r:n@.(B
*/


void makerow(int number)
{
	Symbol *sp=makesymbol(ROW,NULL); /* $B:n@.(B */
	appendchildren1(sp,number);
	push(sp);
}


Symbol *makerange()      /* $BHO0O(B */
{
  Symbol *range=makesymbol(RANGE,NULL);
  appendchildren1(range,2);
  push(range);
  return range;
}


Symbol *makerangestep()  /*$B%9%F%C%WIU$-HO0O(B(init:step:end) 1:3:10- > 1..10:3 */
{
  Symbol *rangestep=makesymbol(RANGEST,NULL);  /* rangestep */
  appendchildren1(rangestep,3);
  swap(rangestep,1,2);
  push(rangestep);
  return rangestep;
}


void swap(Symbol *sp,int m,int n)
{
  Symbol *tmp=sp->childp[m];
  sp->childp[m]=sp->childp[n];
  sp->childp[n]=tmp;
}

