#include "tfb2any.h"
#include<string.h>
#include<stdlib.h>


typedef struct Hensu{   /* $BJQ?t%j%9%H8!:w@lMQ9=B$BN(B */
  char *name;     /* $BJQ?tL>(B */
  struct Hensu *next;
}Hensu;


typedef struct RangeHensu{   /* RANGE$BBeF~%j%9%H8!:w@lMQ9=B$BN(B */
  char *name;  /* $BL>A0(B */
  Symbol *root;    /* range$B%j%9%H$N:,$X$N%]%$%s%?(B  */
  struct RangeHensu *next;
}RangeHensu;

char *emalloc(unsigned);

Symbol *makesymbol(short type,short mode,char *value) /* make symbol */
{
  Symbol *sp;   /* symbol pointer */
  Symbol **childp;  /* pointer to Symbol pointer */
  sp=(Symbol *)emalloc(sizeof(Symbol));
  sp->type=type;
  sp->mode=mode;    
  if(value!=NULL){
	sp->value=(char *)emalloc(strlen(value)+1);   /* +1 for '\0' */
	strcpy(sp->value,value);
  }
  else
	sp->value=NULL;    /* $B0l1~(B */
  childp=(Symbol **)emalloc(CHILD*sizeof(Symbol *)); /* Symbol$B$X$N(B */
  sp->childp = childp;   /* $B%]%$%s%?G[Ns$X$N%]%$%s%?(B  */
  sp->number=0;        /* $B;R6!$N?t$O:G=i$O#0(B */
}

char *emalloc(unsigned n)    /* check return from malloc and initialize */
{
  int i;
  char *p;
  p=(char *)malloc(n);
  if(p==0)
	execerror("out of memory",(char *)0);
  for(i=0;i<n;i++)
	*(p+i)=0;          /* $B=i4|2=(B */
  return p;
}




/*
  $B$3$3$h$j2<$OJQ?t$N4IM}$r$9$k4X?t72(B
  $B9=B$BN%a%s%P(B name : $BL>A0(B
               next  : $B<!$X$N%]%$%s%?(B
*/


static Hensu *hensulist=0;   /* $BITDj85$N%F!<%V%k!'DL>o$N%j%9%H(B */


/*
  $BJQ?t%j%9%H$N8!:w(B
*/
int lookup(char *name)
{
  Hensu *hp;
  for(hp=hensulist;hp!=(Hensu *)0;hp=hp->next)
	if(strcmp(hp->name,name)==0)
	  return 1;     /* found */
  return 0;       /* not found */
}


/*
  $BJQ?t$NDI2C(B
*/
void install(char *name)
{
  Hensu *hp;
  hp=(Hensu *)emalloc(sizeof(Hensu));
  hp->name=(char *)emalloc(strlen(name)+1);  /* +1 for '\0' */
  strcpy(hp->name,name);
  hp->next=hensulist;   /* put at front of list  */
  hensulist=hp;
}


/*
  $B%j%9%H$+$i(Bvar$B$H0lCW$9$k%a%s%P$r;}$D9=B$BN$r:o=|(B
*/

void var_remove(char *var)
{
  Hensu *hp;     
  if(strcmp(var,hensulist->name)==0){      /*$B@hF,%a%s%P#1$D$G(BHIT$B$7$?$H$-(B  */
	/*printf("%s$B:o=|(B",hensulist->name);*/
	hensulist=hensulist->next;
	return ;
  }
  for(hp=hensulist;hp!=(Hensu *)0;hp=hp->next){
	if(hp->next!=NULL){
	  if(strcmp(var,(hp->next)->name)==0){
		/*printf("%s$B:o=|(B",hp->next->name);*/
		hp->next=(hp->next)->next;
		return ;
	  }
	}
  }
}







/*
  $B$3$3$h$j2<$O(Brange$B$rBeF~$7$?JQ?t$N4IM}$r$9$k4X?t72(B
  $B9=B$BN%a%s%P(B name  : $BL>A0(B
               root  : $BBeF~J8$r%j%9%H$KJQ49$7$?8e$N%j%9%H$X$N%]%$%s%?(B
               next  : $B<!$X$N%]%$%s%?(B
  $BNc!'(Bx=0..1:2 $B$d(B x=0..1 $B$N$h$&$JJ8$rH/8+$7$?$i(B
  x$B$r(Bname,[x,0,1]$B%j%9%H$X$N%]%$%s%?$r(Broot$B$H$7$FEPO?(B
  ($B8e$KHO0O$r<($9%j%9%H$,I,MW$J4X?t$N0z?t$H$7$FIU$12C$($k$?$a(B)
*/


static RangeHensu *rangehensulist=0; /* range$BITDj85$N%F!<%V%k!'DL>o%j%9%H(B */

/*
  range$BJQ?t%j%9%H$N8!:w(B
  $B$_$D$+$C$?$iA^F~$7$?$$%j%9%H$X$N%]%$%s%?(B,$BL5$1$l$P(BNULL$B$rJV$9(B
*/
Symbol *lookup_rangevar(char *name)
{
  RangeHensu *rhp;
  for(rhp=rangehensulist;rhp!=(RangeHensu *)0;rhp=rhp->next)
	if(strcmp(rhp->name,name)==0)
	  return rhp->root;     /* found */
  return NULL;       /* not found */
}


/*
  range$BJQ?t$NEPO?(B
*/
void install_rangevar(char *name,Symbol *root)
{
  RangeHensu *rhp;
  rhp=(RangeHensu *)emalloc(sizeof(RangeHensu));
  rhp->name=(char *)emalloc(strlen(name)+1);  /* +1 for '\0' */
  strcpy(rhp->name,name);
  rhp->root=root;   /* $BLZ$NJ]B8(B */
  rhp->next=rangehensulist;   /* put at front of list  */
  rangehensulist=rhp;
}

/* $B:o=|(B */
void rangevar_remove(char *var)
{
  RangeHensu *rhp;     
  if(strcmp(var,rangehensulist->name)==0){ /*$B@hF,%a%s%P#1$D$G(BHIT$B$7$?$H$-(B  */
	rangehensulist=rangehensulist->next;
	return ;
  }
  for(rhp=rangehensulist;rhp!=(RangeHensu *)0;rhp=rhp->next){
	if(rhp->next!=NULL){
	  if(strcmp(var,(rhp->next)->name)==0){
		rhp->next=(rhp->next)->next;
		return ;
	  }
	}
  }
}


/*$B%j%9%H$KEPO?$5$l$F$$$kJQ?t$N8D?t$r7W;;(B*/
int rangelist_number()
{
  int i;   /*$B8D?t%+%&%s%?(B*/
  RangeHensu *rhp;
  i=0;
  for(rhp=rangehensulist;rhp!=(RangeHensu *)0;rhp=rhp->next)
	i++;
  /*  printf("$BEPO?8D?t$O(B%d",i); for debug  */
  return i;
}


/* i$BHV(B(1$B$+$i%+%&%s%H(B)$BL\$NEPO?$5$l$F$$$kL>A0$N<h$j=P$7(B */
char *rangevar_pickup(int i)
{
  RangeHensu *rhp;
  int counter=0;
  int number=rangelist_number();
  if(i==1){  /* 1$BHVL\<h$j=P$9;~$@$1FCJL(B*/
	if(rangehensulist==NULL)
	  execerror("rangevar,out of range",(char *)0);
	return rangehensulist->name;
  }
  if(number==0 || number<i)  /* $BEPO??t$,(B0,or$BEPO??t$h$jBg$-$$HV9f$r;XDj(B */
	return NULL;
  /* 2$BHVL\0J9_$r<h$j=P$9;~(B */
  for(rhp=rangehensulist;rhp!=(RangeHensu *)0 && counter<i-2;rhp=rhp->next)
	counter++;        /*$B#1$D<jA0$^$GJb$r?J$a$k(B*/
  if(rhp->next==NULL){
	/*	printf("\n%d$B8D(Bdasi\n",i);
		printf("%s\n",rhp->name);
		printf("counter$B$O(B%d\n",counter); for debug */
	execerror("rangevar,out of range",(char *)0);   /*$B%G%P%C%0(B*/
  }
  else
	return rhp->next->name;
}

