#include "../common_file/tfb2any.h"
#include "y.tab.h"
#include<stdio.h>

/******************
$B9=J8LZ$NI=<((B
maple$B$K(B
*******************/

void module_print(char *);

void printend(int flag)
{
  if(flag==0)
	printf(";\n");
  else
	printf(":\n");
}


void print_expr()   /* $BJQ49$7$F$+$i0u;z(B  */
{
  Symbol *sp=pop();
  transform(sp);   /* $BJQ49(B  */
  treeprint(sp);   /* $B0u;z(B */
}


/* tfb2maple$B$G$O#3$D$a$N0z?t$O0UL#$r$b$?$J$$(B */
void treeprint(Symbol *sp)
{
  int i;
  if(sp->number==0){     /* $B;R6!$,(B1$B?M$b$$$J$$$H$-$O$=$l$r0u;z(B */
	check_type(sp,1,0);
	if(sp->type==LIST||sp->type==SET||sp->type==FUNCTION||sp->type==MODULE)/* $B%j%9%H$H4X?t$O(B */
	  check_type(sp,2,0);                   /* $B;R6!$,$$$J$/$F$bJD$83g8LI,MW(B */
	return ;
  }
  else{   /* $B;R6!$,$$$k$H$-$K$O;R6!$r0u;z(B($B:F5"!K(B */
	check_type(sp,1,0);         /* $B;R6!$r0u;z$9$kA0$K3g8L3+$-!)(B  */
	for(i=0;i<sp->number;i++){
	  treeprint(*((sp->childp)+i));  /* $B;R6!$KBP$7$FF1$8Av::(B */
	  if(i<sp->number-1)/*$B:G8e$N%3%s%^(B.$B$$$l$J$+$C$?$i:G8e$K%3%s%^$,#1$DM>J,(B*/
		check_type(sp,3,i);  /* $B%j%9%H$d4X?t$J$i;R6!$N4V$K%3%s%^$,F~$k(B */
	}
	check_type(sp,2,0);    /* $B;R6!$r0u;z$7$?$"$H3g8LJD$8!)(B */
  }
}


/*
  check_type
  $B%N!<%I$N<oN`$H#2$D$a$N0z?t!J%N!<%IAv::Cf$N(B $B@h(B:$B#1(B $BCf(B:$B#3(B $B8e(B:$B#2(B $B$N$I$l$+!K(B
  $B$K$h$C$FI=<($r@Z$jBX$($k4X?t(B
  $B#3$D$a$N0z?t$O0UL#$J$7(B
*/
void check_type(Symbol *sp,int time,int childnum)
{
  switch(sp->type){
  case NUMBER:
  case VAR:
  case HUTEIGEN:
  case PREVIOUS:
	if(time==1)
	  printf("%s",sp->value);
	break;

  case CONST:
	if(time==1)
	  printf("%s",sp->value);
	break;
  case STRING:
	if(time==1)
	  printf("\"%s\"",sp->value);
	break;

  case FUNCTION:
	if(time==1){    /* $B@h(B */
	  if(strcmp(sp->value,"erase")!=0)/*$B4X?tL>$,(Berase->$B4X?tL>$H%+%C%3HsI=<((B */
		printf("%s(",sp->value);
	}
	else if(time==2){   /* $B8e(B */
	  if(strcmp(sp->value,"erase")!=0)/*$B4X?tL>$,(Berase->$B4X?tL>$H%+%C%3HsI=<((B */
		printf(")");
	}
	else if(time==3)   /* $BCf(B */
	  printf(",");
	break;

  case MODULE:    /* $B%b%8%e!<%k4X?t(B */
	if(time==1){    /* $B@h(B */
	  module_print(sp->value);
	  printf("](",sp->value);
	}
	else if(time==2)   /* $B8e(B */
	  printf(")");
	else if(time==3)   /* $BCf(B */
	  printf(",");
	break;


  case PARENS:
	if(time==1)
	  printf("(");
	else if(time==2)
	  printf(")");
	break;

  case LIST:
  case ROW:
  case MATRIX:
	if(time==1)
	  printf("[");
	else if(time==2)
	  printf("]");
	else if(time==3)
	  printf(",");
	break;

  case SET:
	if(time==1)
	  printf("{");
	else if(time==2)
	  printf("}");
	else if(time==3)
	  printf(",");
	break;	

  case UNARYMINUS:
  case UNARYPLUS:
	if(time==1)
	  printf("%s",sp->value);
	break;

  case ELEMENT:   
	if(time==1){
	  if(sp->value!=NULL)
		printf("%s[",sp->value);
	  else
		printf("[");
	}
	else if(time==2)
	  printf("]");
	else if(time==3)
	  printf(",");
	break;

  case OPE:
	if(time==3)
	  printf("%s",sp->value);
	break;

  case RANGE:     
  case RANGEST:
	if(time==3)
	  printf("..");
	break;

  case ASSIGN:
	if(time==3)
	  printf(":=");
	break;

  case EQ:   /* $BJ}Dx<0(B */
	if(time==3)
	  printf("=");
	break;

  case FUNCTIONELEMENT:    /* $B2?$b$7$J$$?F(B */
	break;

  case VECTOR:     /* $B0J2<(Btest */
	if(time==1)
	  printf("<");
	else if(time==2)
	  printf(">");
	else if(time==3){
	  printf(",");
	}
	break;
	
  case COLUMN:    /* $BNs$N6h@Z$j(B  */
	if(time==1)  /* $BA0$N(B,$B$r>C$7$F!#!#(B\b$B>C$7$?$iI,MW$JM}M3$o$+$k$+$b(B */
	  printf("\b%s",sp->value);   /*$B=DK@$r;R6!$rI=<($9$k$^$($K0u;z(B  */
	break;


  case DUMMYCOMMA:   /* $BJQ49;~$K$&$^$l$k%@%_!<$N?F(B($B%3%s%^$@$1$O$D$1$k(B) */
	if(time==3)
	  printf(",");
	break;    /* $B$J$K$b$7$J$$$,;R6!$N4V$K%3%s%^$@$1$O$$$l$k(B */

  case DP: /* $BJ,;6I=8=B?9`<0(B */
	if(time==1)
	  printf("[");
	else if(time==2)
	  printf("]");
	else if(time==3){
	  printf(",");
	}
	break;
  }
}


void module_print(char *module)
{
  char *p=module;
  while(*p!='\0'){
	if(*p=='.')   /* .->[$B$rI=<((B */
	  printf("[");
	else
	  printf("%c",*p);
	p++;
  }  
}

