#include "../common_file/tfb2any.h"
#include "y.tab.h"
#include<stdio.h>
#include<string.h>
extern int omobj_flag;

/******************
$B9=J8LZ$NI=<((B
openmath XML
*******************/

static int depth=0;  /* for indent:indent$B$N?<$5(B */
void pr_indent(int);   /* indent$B4X?t(B */
void add_head(Symbol *,char *);      /* $B@hF,$KJ8;zNs$rIU$1$($k(B */
void print_omsymbol(Symbol *);
void print_cdname_name(char *,char *); /*$B4X?t(Bcdname name$B$r0u;z(B*/
void print_ope(Symbol *);
void soft_symbol(int);    
/* 
   $B%=%U%HL>(B@$B4X?t$N$H$-$N0u;z$N;EJ}(B
   asir@plot
   --> <OMS cd="asir_symbol" name="plot" />
*/


void printend(int flag)
{
  if(flag==0)
	printf("\n");
  else{
	printf("\n");
  }
}


void print_expr()  
{
  Symbol *sp=pop();
  if(omobj_flag==1){
	printf("<OMOBJ xmlns=\"http://www.openmath.org/OpenMath\" version=\"2.0\" cdbase=\"http://www.openmath.org/cd\">\n");
	depth++;
  }
  treeprint(sp);   /* $B0u;z(B */
  if(omobj_flag==1){
	depth--;
	printf("</OMOBJ>\n");
  }
}


void treeprint(Symbol *sp)
{
  int i;
  if(sp->number==0){     /* $B;R6!$,(B1$B?M$b$$$J$$$H$-$O$=$l$r0u;z(B */
	check_type(sp,1,0);
	if(sp->type==FUNCTION || sp->type==DOT_FUNC) /*hoge.a hoge@a$B$OJD$8%+%C%3(B */
	  check_type(sp,2,0); 
	return ;
  }
  else{   /* $B;R6!$,$$$k$H$-$K$O;R6!$r0u;z(B($B:F5"!K(B */
	check_type(sp,1,0);         /* $B;R6!$r0u;z$9$kA0$K3g8L3+$-!)(B  */
	for(i=0;i<sp->number;i++){
	  treeprint(*((sp->childp)+i));  /* $B;R6!$KBP$7$FF1$8Av::(B */
	  if(i<sp->number-1)/*$B:G8e$N%3%s%^(B.$B$$$l$J$+$C$?$i:G8e$K%3%s%^$,#1$DM>J,(B*/
		check_type(sp,3,i);  /* $B%j%9%H$d4X?t$J$i;R6!$N4V$K%3%s%^$,F~$k(B */
	}
	check_type(sp,2,sp->number-1);    /* $B;R6!$r0u;z$7$?$"$H3g8LJD$8!)(B */
  }
}


/*
  check_type
  $B%N!<%I$N<oN`$H#2$D$a$N0z?t!J%N!<%IAv::Cf$N(B $B@h(B:$B#1(B $BCf(B:$B#3(B $B8e(B:$B#2(B $B$N$I$l$+!K(B
  $B$K$h$C$FI=<($r@Z$jBX$($k4X?t(B
  print_depth$B$r=q$-$^$/$i$J$/$F$$$$$h$&$K$&$^$/4X?t2=$9$l$P$h$+$C$?(B...
*/
void check_type(Symbol *sp,int time,int childnum)
{
  switch(sp->type){
  case NUMBER:
	if(time==1){
	  pr_indent(depth);   /* for indent */
	  printf("<OMI>%s</OMI>\n",sp->value);
	}
	break;

  case DEC:
	if(time==1){
	  pr_indent(depth);  /* for indent */
	  printf("<OMF dec=\"%s\" />\n",sp->value);
	}
	break;
	
  case HUTEIGEN:
  case VAR:
	if(time==1){
	  pr_indent(depth);   /* fot indent */
	  printf("<OMV name=\"%s\" />\n",sp->value);
	}
	break;
	
  case STRING:
	if(time==1){
	  pr_indent(depth); /* for indent */
	  printf("<OMSTR>%s</OMSTR>\n",sp->value);
	}
	break;
	
  case DOT_FUNC:   /* a.b  */
	if(time==1){    /* $B@h(B */
	  pr_indent(depth);  /* for indent */
	  printf("<OMA>\n");
	  depth++;
	  print_omsymbol(sp);  /* print openmath symbol */
	}
	else if(time==2){   /* $B8e(B */
	  depth--;
	  pr_indent(depth);  /* for indent */
	  printf("</OMA>\n");
	}
	break;
	
	
  case FUNCTION:   /* a@b */
	if(time==1){    /* $B@h(B */
	  pr_indent(depth);  /* for indent */
	  printf("<OMA>\n");
	  depth++;
	  pr_indent(depth);
	  printf("<OMS cd=\"");
	  soft_symbol(sp->mode);
	  printf("\" name=\"%s\" />\n",sp->value); /*$B$H$j$"$($:(Bhoge$B$r(Bcd$BL>$K(B */
	}
	else if(time==2){   /* $B8e(B */
	  depth--;
	  pr_indent(depth);  /* for indent */
	  printf("</OMA>\n");
	}
	break;
	
  case UNARYMINUS:    /* unaryplus$B$OL5;k(B */
	if(sp->childp[0]->type==NUMBER||sp->childp[0]->type==DEC){/*1$B?M$7$+$$$J$$;R6!$,(BNUMBER$B$+$^$?$O(BDEC*/
	  if(time==1){
		add_head(sp->childp[0],"-");  /* $B;R$N@hF,$K(B"-"$B$rIU2C(B */
		break;
	  }
	}
	else{   /* $B?t;z0J30(B */
	  if(time==1){
		pr_indent(depth);
		printf("<OMA>\n");
		depth++;
		print_cdname_name("arith1","unary_minus");
	  }
	  else if(time==2){
		depth--;
		pr_indent(depth);
		printf("</OMA>\n");
	  }
	}
	break;

  case LIST:   /* $B%j%9%H(B */
	if(time==1){    /* $B@h(B */
	  pr_indent(depth);  /* for indent */
	  printf("<OMA>\n");
	  depth++;
	  pr_indent(depth);
	  printf("<OMS cd=\"list1\" name=\"list\" />\n"); /* $B%j%9%H(B */
	}
	else if(time==2){   /* $B8e(B */
	  depth--;
	  pr_indent(depth);  /* for indent */
	  printf("</OMA>\n");
	}
	break;
	
  case OPE:
	if(time==1){
	  pr_indent(depth);
	  printf("<OMA>\n");
	  depth++;
	  print_ope(sp);
	}
	else if(time==2){
	  depth--;
	  pr_indent(depth);
	  printf("</OMA>\n");
	}
	break;
	
  case EQ:
	if(time==1){
	  pr_indent(depth);
	  printf("<OMA>\n");
	  depth++;
	  print_cdname_name("relation1","eq");
	}
	else if(time==2){
	  depth--;
	  pr_indent(depth);
	  printf("</OMA>\n");
	}
	break;
  }
}


void pr_indent(int d) /* $B?<$5J,$@$1(Bindent$B$9$k(B */
{
  int i;
  for(i=d;i>0;i--)
	printf("   ");
}


void add_head(Symbol *sp,char *string)
{
  char *tmp;
  int i=strlen(string);
  /* +i for append string */
  tmp=(char *)emalloc(strlen(sp->value)+i+1); /* +1 for '\0' */
  /* $BIU$12C$($kJ8;zJ,$rIU$12C$($?%a%b%j$N3NJ]@.8y(B */
  strcat(tmp,string);   /* NULL$BJ8;zNs$K(Bstring$B$rIU$12C$((B */
  strcat(tmp,sp->value);   /* $B$5$i$K(Bvalue$B$NIU$12C$((B */
  sp->value=tmp;
}


void print_omsymbol(Symbol *sp) /*cdname.$B4X?tL>$r(Bcd=$B$H(Bname=$B$KJ,$1$F0u;z(B*/
{
  int i;
  char *p=sp->value;
  pr_indent(depth);   /* for indent */
  printf("<OMS cd=\""); 
  for(i=0;p[i]!='.';i++)   /* .$B$,=P$k$^$G0u;z(B(cdname) */
	printf("%c",p[i]);

  printf("\" name=\"");

  i++;
  if(p[i]=='\0')
	execerror("invalid function to tfb2openmath",(char *)0);
  for( ;p[i]!='\0';i++)       /*$B=*$o$j$^$G0u;z(B(name)*/
	printf("%c",p[i]);
  printf("\" />\n");
}


void print_ope(Symbol *sp)
{
  if(strcmp("+",sp->value)==0)
	print_cdname_name("arith1","plus");
  if(strcmp("-",sp->value)==0)
	print_cdname_name("arith1","minus");
  if(strcmp("*",sp->value)==0) 
	print_cdname_name("arith1","times");
  if(strcmp("/",sp->value)==0) 
	print_cdname_name("arith1","divide");
  if(strcmp("^",sp->value)==0)
	print_cdname_name("arith1","power");
}


void print_cdname_name(char *cdname,char *name)
{
  pr_indent(depth);
  printf("<OMS cd=\"%s\" name=\"%s\" />\n",cdname,name);
}


void soft_symbol(int soft)
{
  if(soft==ASIR)
	printf("asir_symbol");
  if(soft==MATH)
	printf("math_symbol");
  if(soft==MAPLE)
	printf("maple_symbol");
  if(soft==MATLAB)
	printf("matlab_symbol");
}
