%{
  #include "../common_file/tfb2any.h"
  Symbol *msub(void);    /*$B2<E:;zMQ(B */
  Symbol *subsup(void);  /* $B>e2<N>J}$KE:;z(B */
  Symbol *under(void);  /* $B2<J8;zMQ(B */
  Symbol *over(void);   /* $B>eJ8;zMQ(B */
  Symbol *underover(void); /* $B>e2<J8;zMQ(B */
  Symbol *makesqrt(void);  /* $B%k!<%H(B */
  Symbol *makeroot(void);  /*n$B>h:,(B*/
  int math_flag=0;     /* MATH$B%?%0$r=PNO$9$k$+H]$+(B */
%}

%union{   /* type of yylval */
  int narg;   /* number of args */
  Symbol *sym; /* pointer to symbol */
}

/*
  pmathml:presentation mathml$B$NN,(B
  $B;n:nIJ(B:tfb($BCf4V8@8l(B)$B$O$[$\(BAsir$B$HF1$8J8K!!#(B
  $BJQ?t(B   $BBeF~$5$l$?ITDj85(B
  $BITDj85(B $BB?9`<0$NJQ?t$N$3$H(B
  sin(x) --> sin(x) $B$HI=<((B
  sin[x] --> sinx   $B$H%+%C%3L5$7$NI=<($K$J$k(B
*/

/* 
   tfb2pmathml$B$G$O;H$o$l$J$$%H!<%/%s$bB?!94^$^$l$F$$$k(B 
*/
%start list    /* $B%G%U%)%k%H$G$O(B1$BHV>e$N5,B'$+$i;O$^$k$N$G$3$l$O$J$/$F$b$h$$(B */
%token<sym> NUMBER VAR HUTEIGEN STRING /*HUTEIGEN:$BITDj85!J?t3X$G$NJQ?t(B)*/  
%token <sym>FUNCTION PREVIOUS CONST /* VAR:$B%W%m%0%i%_%s%0$G$NJQ?t(B */
/* FUNCTION$B$O%=%U%HL>(B@$B4X?tL>$N%H!<%/%s(B */
%token<sym> MODULE  /* $B;H$o$J$$(B:yylex$B%(%i!<$N2sHr(B */
%token VECTOR COLUMN     /* $BJQ49BP>]$K$J$k$+$OHyL/(B  */
%token SET     /* $B=89g(B */
%token ROW MATRIX /* $B9TNs$N9T(B,$B9TNs(B */
%token RANGE RANGEST    /* $BHO0OI=8=(B(1..2$B$N(B..) , step$BIU$-HO0O(B */
%token PARENS LIST OPE ASSIGN      /* $B>.3g8L$HBg3g8L$H1i;;;R$HBeF~1i;;;R(B */
%token ELEMENT            /* $BMWAGCj=P$N:]$NJQ?t(B  */
%token FUNCTIONELEMENT    /* $B4X?t8F$S=P$7$N$"$H$KMWAGHV9f$,$D$$$?>l9g(B */
%token DUMMYCOMMA   /* $B%@%_!<$N?F(B */

%token INV_FUNC /*tfb2pmathml$B@lMQ(B: sinx$B$N$h$&$K0z?t$r%+%C%3$G0O$^$J$$4X?tI=<((B*/
%token P_FUNCTION /* tfb2pmathml$B@lMQ(B:sin(x)$B$N$h$&$J<+A3$J4X?t(B */

%token UNDER OVER  /* tfb2pmathml$B@lMQ(B:__$B$H(B^^ */
%token UNDEROVER
%token SQRT ROOT   /* tfb2pmathml$B@lMQ(B:$B%k!<%HI=<($HN_>h:,I=<((B */
%type<sym> expr
%type<narg> datalist end


%right '='
%left EQ    /* ==$B$N$3$H(B:$BJ}Dx<0(B */
%left '+' '-'
%left '*' '/'
%left UNARYMINUS UNARYPLUS   /* $BC19`%^%$%J%9(B,$B%W%i%9(B */
%right '^' '_' SUBSUP UNDER OVER    /*$BM%@h=g0L$OF~$l49$($k$+$b(B*/
%%


/*
  $B?t<0I=8=$KBeF~(B(asgn)$B$dHO0O(B(range)$B2?$+$"$k$O$:$b$J$$(B
*/

list:   /* nothing */
| list end
| list expr end  {print_expr(); printend($3);}
| list error end {yyerrok;}
;

end: ';' {$$=0;math_flag=0;}
| '$'    {$$=1;math_flag=1;}
;

/***************
NUMBER:$B?t;z(B
VAR:$BJQ?t(B
HUTEIGEN:$BITDj85(B
STRING:$BJ8;zNs(B
CONST:$BDj?t(B
$BB>$H$O0c$$(BFUNCTION$B%H!<%/%s$OJ8L.$+$i7h$^$k(B
***************/

expr: NUMBER {push($1); $$=$1;} 
| VAR        {push($1); $$=$1;}
| HUTEIGEN   {push($1); $$=$1;}
| STRING     {push($1); $$=$1;}
| CONST      {push($1); $$=$1;}  
| HUTEIGEN '(' datalist ')' {$1->type=P_FUNCTION; $$=makefunc($1,$3);} /* $BIaDL$N4X?t(B*/
| HUTEIGEN '[' datalist ']' {$1->type=INV_FUNC; $$=makefunc($1,$3);}
| FUNCTION '(' datalist ')' {$$=makefunc($1,$3);}  /* $B%=%U%HL>(B@$B4X?tL>$NJ}(B*/
| MODULE '(' datalist ')' {$$=makefunc($1,$3);}
| '(' expr ')' {$$=kakko();}   /* $B%V%m%C%/2=(B+$B%+%C%3I=<((B */
| '{' expr '}' {$$=$2;}      /* $B%V%m%C%/2=(B+$B%+%C%3HsI=<((B */
| expr '+' expr {$$=add();}
| expr '-' expr {$$=sub();}
| expr '*' expr {$$=mul();}
| expr '/' expr {$$=divide();}
| expr '^' expr {$$=power();}
| expr '_' expr {$$=msub();}    /* msub$B4X?t$O$3$N%U%!%$%k$N0lHV2<$K(B:$B2<E:;z(B */
| expr SUBSUP '(' expr ',' expr ')' {$$=subsup();}
| expr UNDER OVER '(' expr ',' expr ')' {$$=underover();}
| expr UNDER expr {$$=under();}
| expr OVER expr {$$=over();}
| expr EQ expr {$$=make_eq();}     /* $BJ}Dx<0(B */
| SQRT '(' expr ')' {$$=makesqrt();}    /* $B%k!<%H(B */
| ROOT '(' expr ',' expr ')' {$$=makeroot();}    /* n$B>h:,(B */ 
| '-' expr   %prec UNARYMINUS {$$=unaryminus();} 
| '+' expr   %prec UNARYPLUS  {$$=unaryplus();}
| '[' datalist ']' {$$=makelist($2);}  /* list or vector */ 
;


/* $B0z?t$d%j%9%H$J$I$G$N%G!<%?$N%j%9%H(B */
datalist:  {$$=0;}  /* nothing */ 
| expr     {$$=1;}   
| datalist ','  expr {$$=$1+1;}
;
%%
/* end of grammer */


#include<stdio.h>
#include<ctype.h>
#include<setjmp.h>
#include<string.h>
char *progname;
int lineno=1;    /* for error message */
jmp_buf begin;

short target=PMATHML;    /* $BJQ49$7$?$$?t3X%=%U%H(B */

main(int argc,char *argv[])
{
  progname=argv[0];
  setjmp(begin);
  yyparse();
}


int yyerror(char *s) /* call from yyparse when syntax error exists */
{
  warning(s,(char *)0);
}


int warning(char *s,char *t)
{
  fprintf(stderr,"%s: %s",progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  fprintf(stderr," near line %d\n",lineno);
}


void execerror(char *s,char *t)
{
  warning(s,t);
  init();
  longjmp(begin,0);
}


void execerror2(char *s,char *t,char *u)   /* $B%(%i!<%a%C%;!<%8$rA}$d$7$?$$(B */
{
  fprintf(stderr,"%s: %s" ,progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  if(u!=0)
	fprintf(stderr," %s",u);
  fprintf(stderr," near line %d\n",lineno);
  init();
  longjmp(begin,0);
}



/*
  tfb2pmathml$B@lMQ$N9=J8LZ:n@.4X?t(B
  sub:$B2<E:;z(Boperator _
  subsup:$B2<$+$D>eE:;z(B _^
  over: $B>eJ8;z(B ^^
  under:$B2<J8;z(B __
  underover: $B>e$+$D2<J8;z(B  __^^
*/

Symbol *msub()
{
  Symbol *sp=makesymbol(OPE,NONE,"_");
  appendchildren1(sp,2);   /* $BHo1i;;;R$V$i2<$2(B */
  push(sp);
  return sp;
}


Symbol *subsup()
{
  Symbol *sp=makesymbol(OPE,NONE,"_^");
  appendchildren1(sp,3);   /* $B$V$i2<$2(B */
  push(sp);
  return sp;
}


Symbol *under()
{
  Symbol *sp=makesymbol(OPE,NONE,"__");
  appendchildren1(sp,2);   /* $BHo1i;;;R$V$i2<$2(B */
  push(sp);
  return sp;  
}


Symbol *over()
{
  Symbol *sp=makesymbol(OPE,NONE,"^^");
  appendchildren1(sp,2);   /* $BHo1i;;;R$V$i2<$2(B */
  push(sp);
  return sp;
}


Symbol *underover()
{
  Symbol *sp=makesymbol(OPE,NONE,"__^^");
  appendchildren1(sp,3);   /* $BHo1i;;;R$V$i2<$2(B */
  push(sp);
  return sp;  
}


Symbol *makesqrt()
{
  Symbol *sp=makesymbol(SQRT,NONE,NULL);
  appendchildren1(sp,1);   /*$B$V$i2<$2(B */
  push(sp);
  return sp;   
}


Symbol *makeroot()
{
  Symbol *sp=makesymbol(ROOT,NONE,NULL);
  appendchildren1(sp,2);   /* $B$V$i2<$2(B */
  push(sp);
  return sp;  
}
